# Backtrace Workflows 2.0

Backtrace workflows service - the replacement for the Backtrace coronerd workflows scripts python package. This
repository contains a code of the service responsible for all workflows integrations.

## How to build and run

To run service you need to use node 16.

```
git submodule update --init --recursive
npm install
npm run build
npm run start
```

## Testing

The service contains unit & e2e tests. To run tests use the following command:

```
npm run test
```

The repository contains a postman collection with sample requests that anyone can use to validate and test the workflows
service behavior. To import collection you need to install Postman. After importing the collection, navigate to the
collection options and modify collection parameters like serviceUrl oraz coronerd information.

## Development

By default, configuration allows you to create an sqlite3 database on your backtrace box. However, the service allows
you to use postgres. To quickly test the service with postgres, you can use docker container and run the following
command:

```
  docker run  -e POSTGRES_DB=workflows -e POSTGRES_USER=user -e POSTGRES_PASSWORD=test -d -p 5432:5432 postgres
```

and next by modyfing the workflows.conf available in the root directory by replacing database references to:

```
 "database": {
        "type": "postgres",
        "host": "localhost",
        "port": 5432,
        "username": "user",
        "password": "test",
        "database": "workflows"
    },
```

## Pre-migration coronerd integration

In order to disable the workflows scripts in coronerd, you can add to the coronerd.conf a feature flag following URL on
localhost:

```
 "feature_flags": [
    "-watcher:enabled.*"
  ],
```

or execute the following command:

```
sudo curl --unix-socket /var/run/coronerd/listeners/local_admin.socket http://coronerd/_local_admin/feature_flags/flip -d '["-watcher:enabled.*"]'
```

If you need to re-enable the old workflows integration - remove the flag, or execute the following command:

```
sudo curl --unix-socket /var/run/coronerd/listeners/local_admin.socket http://coronerd/_local_admin/feature_flags/flip -d '["+watcher:enabled.*"]'
```

### Alert integration

To integrate with alerts you need to install the service called: `backtrace-coronerd-workflow-proxy`. The service should
replace the old package `backtrace-coronerd-workflow`. By doing that, all workflows request that the alert service make,
will be proxed via the proxy script to the service.
